package
{
	import flash.geom.Point;
	import flash.globalization.StringTools;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.TiledImage;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import flash.utils.ByteArray;
	import flash.display.BitmapData;
	
	public class DynamicTilemap extends Entity
	{
		public var collision:Grid = null;
		public var map:Vector.<uint>;
		public var w:uint, h:uint,tw:uint,th:uint,sx:uint,sy:uint,anim:uint=0;
		public var tiles:Spritemap;
		
		public function DynamicTilemap(w:uint, h:uint)
		{
			// setting up the dimensions
			this.w = w;
			this.h = h;
			
			// creating a static sized tilemap
			map = new Vector.<uint>(w * h, true);
			
			// entity type for collisions
			type = "level";
			layer = 10;
			
		}
		
		// loading the level
		// you can extend this to create levels procedurally
		public function load(img:Class, map:Class,tile_w:uint,tile_h:uint):void
		{
			// setting up tile dimensions
			tw = tile_w;
			th = tile_h;
			
			sx = tw * w;
			sy = th * h;
			
			// tile graphics
			tiles = new Spritemap(img, tw, th);
			
			// collision grid
			collision = new Grid(w * tw, h * th, tw, th, 0, 0);
			mask = collision;
			
			// reading the binary map file
			var b:ByteArray = new map();
			var maxTile:uint = 0;
			Q.target = new Vector.<Target>;
			Q.morepeople = new Vector.<Man>;
			Q.active = null;
			var manwindow:int = -1;
			//iterating through the data and creating the level
			for (var yy:uint = 0; yy < h; yy ++)
			{
				for (var xx:uint = 0; xx < w; xx ++)
				{
					// read tile data
					var tile:uint = b.readUnsignedByte();
					
					
					// 0 tile is the no-tile thing
					// default tile Studio blank tile is 0xff (255)
					if (tile == 0xff) tile = 0;
					
					// here, we check if the tile is actually a tile
					// e.g. tile 0xc0 (192) represents
					// player starting position
					// add more cases to create enemies, coins or whatever
					if (tile == 0x80 || tile==134)
					{
						// creating the player
						// not that the coords are multiplied 
						// by tile size
						if (!Q.player) 
							Q.player = new Player(xx * tw, yy * th);
						else
						{
							Q.player.x = xx * tw;
							Q.player.y = yy * th;
						}
						FP.world.add(Q.player);
						//tile = 0;
						if (tile == 134) set_at(xx, yy, 112);
						
					} else if (tile == 0x81)
					{
						// another case
						if (Q.people.length)
						{
							for (var c:uint = 0; c < Q.people.length; c++)
						{
							var man:Man = Q.people[c];
							man.x = xx * tw + FP.rand(tw * 8);
							man.y = yy * th - FP.rand(th * 8);
							if (!man.dead) 
							{
								//trace("readding man!");
								FP.world.add(man);
							}
							//Q.people.push(man);
						}
						} else {
						for (var c:uint = 0; c < Q.mans; c++)
						{
							var man:Man = new Man(xx * tw + FP.rand(tw * 8), yy * th - FP.rand(th * 8));
							FP.world.add(man);
							Q.people.push(man);
						}
						}
						
					} else if (tile == 132 || tile==133)
					{
						var dir:Boolean = (tile == 132) ? true : false;
						var bx:Number = xx * tw+(dir ?  -150 : 150) ;
						var by:Number = yy * th;
						var vx:Number = (dir ? 1 : -1) * (Math.random() * 3 + 3);
						var vy:Number = 0;
						
						if (!Q.player) 
							Q.player = new Player(bx, by);
						else
						{
							Q.player.x = bx+(dir ?  -75 : 75);
							Q.player.y = by-th*4;
							
						}
						Q.player.vx = vx;
						Q.player.vy = vy;
						Q.player.enter = true;
						FP.world.add(Q.player);
						
						// another case
						if (Q.people.length)
						{
							for (var c:uint = 0; c < Q.people.length; c++)
						{
							var man:Man = Q.people[c];
							man.x = bx + FP.rand(tw * 16) * (dir ? -1 : 1);
							man.y = by - FP.rand(th * 8);
							man.vx = vx;
							man.vy = vy;
							man.enter = true;
							man.jumps = 0;
							if (!man.dead) 
							{
								//trace("readding man!");
								FP.world.add(man);
							}
							//Q.people.push(man);
						}
						} else {
						for (var c:uint = 0; c < Q.mans; c++)
						{
							var man:Man = new Man(bx + FP.rand(tw * 16) * (dir ? -1 : 1), by - FP.rand(th * 8));
							man.vx = vx;
							man.vy = vy;
							man.enter = true;
							man.jumps = 0;
							FP.world.add(man);
							Q.people.push(man);
						}
						}
						set_at(xx, yy, 155);
					} else if (tile == 0x82)
					{
						// another case
						var t:Target = new Target(xx * tw, yy * th,0);
						FP.world.add(t);
						Q.target.push(t);
						if (!Q.active) t.activate(10);
						
					} else if (tile == 0x83)
					{
							var man:Man = new Man(xx * tw+8, yy * th+8);
							FP.world.add(man);
							Q.morepeople.push(man);
						
					} else if (tile == 183 || tile==177)
					{
						// another case
						var what:uint = 0;
						var t:Target;
						if (tile == 183) t = new Target(xx * tw+tw/2, yy * th+th/2,0);
						if (tile == 177) t = new Target(xx * tw, yy * th+th/2,1);
						//if (tile == 179) what = 2;
						
						FP.world.add(t);
						Q.target.push(t);
						if (!Q.active) t.activate(10);
						set_at(xx, yy, tile);
					}else if (tile >= 64 && tile<=70)
					{
						// another case
						var t:Target = new Target(xx * tw, yy * th,tile-64);
						FP.world.add(t);
						Q.target.push(t);
						if (!Q.active) t.activate(10);
						set_at(xx, yy, 43);
					} else if (tile >= 96 && tile<=98)
					{
						if (manwindow < 0)
						{
							Q.player.tx = xx;
							Q.player.ty = yy;
							set_at(xx, yy, 96);
						} else {
							if (manwindow < Q.people.length)
							{
								var m:Man = Q.people[manwindow];
								m.tx = xx;
								m.ty = yy;
								m.x = xx * tw + 8;
								m.y = yy * th + 8;
								set_at(xx, yy, m.dead ? 98 : 97);
							}
						}
						manwindow++;
						
					}  else {
						// if not found anywhere
						set_at(xx, yy, tile);
						
						//use that for something
						if (tile > maxTile) maxTile = tile;
					}
					
				}
			}
			
			for (var yy:uint = 0; yy < h; yy ++)
			{
				for (var xx:uint = 0; xx < w; xx ++)
				{
					// read tile data
					var tile:uint = get_at(xx, yy);
					if (tile > 0xf && tile < 0x20)
					{
						if (get_at(xx + 1, yy) == tile &&
							get_at(xx - 1, yy) == tile &&
							get_at(xx, yy - 1) != tile)
						{
							var f:uint = tile&0xf;
							var t:Target = new Target(xx * tw + th / 2, yy * th + th * 2,f);
							FP.world.add(t);
							Q.target.push(t);
							if (!Q.active) t.activate(1);
						}
					}
				}
			}
			
			for (var yy:uint = 0; yy < h; yy ++)
			{
				for (var xx:uint = 0; xx < w; xx ++)
				{
					// read tile data
					var tile:uint = get_at(xx, yy);
					if (tile > 0xf && tile < 0x20)
					{
						var f:uint = tile&0xf;
						FP.world.add(new Food(xx * tw, yy * th, f));
						FP.world.add(new Food(xx * tw + tw / 2, yy * th, f));
						FP.world.add(new Food(xx * tw, yy * th+th/2,f));
						FP.world.add(new Food(xx * tw + tw / 2, yy * th + th / 2, f));
						set_at(xx, yy, 0x90);
					}
				}
			}
			
			for (var yy:uint = 0; yy < h; yy ++)
			{
				for (var xx:uint = 0; xx < w; xx ++)
				{
					// read tile data
					var tile:uint = get_at(xx, yy);
				}
			}
			
			if (Q.active)
			{
				var index:int = Q.target.indexOf( Q.active );
				Q.target.splice( index, 1 );
				function shuffleVector( a:Object, b:Object ):int
				{
					return Math.floor( Math.random() * 3 - 1 );
				}
				Q.target.sort( shuffleVector );
				while (Q.target.length > 3) Q.target.pop();
			}
		}
		
		
		public function get_at(x:uint, y:uint):uint
		{
			// if overboard, return
			if (x < 0 || y < 0 || x > w - 1 || y > h - 1) return 0;
			// else, return tile
			return map[x+y*w]
		}
		
		public function set_at(x:uint, y:uint,value:uint):void
		{
			// if overboard, return
			if (x < 0 || y < 0 || x > w - 1 || y > h - 1) return;
			
			// else set tile image
			map[x + y * w] = value;
			
			var col:Boolean = true;
			if (!value) col = false;
			if (value > 111) col = false;
			// and collision value
			// set up a condition here if you want non-solid tiles
			collision.setTile(x, y, col);
		}
		
		override public function update():void
		{
			anim++;
		}
		
		 public function render2(shadow:Boolean):void
		{
			// this renders tiles that happen to be on the screen
			var sx:int, sy:int, ex:int, ey:int;
			sx = (FP.camera.x / tw) - 1;
			sy = (FP.camera.y / th) - 1;
			ex = sx + (FP.width / tw) + 2;
			ey = sy + (FP.height / th) + 3;
			if (sx < 0) sx = 0;
			if (sy < 0) sy = 0;
			if (ex > w) ex = w;
			if (ey > h) ey = h;
			if (sx > w || sy > h || ex < 0 || ey < 0) return;
			if (shadow)
			{
				tiles.color = 0;
				tiles.alpha = .5;
			} else {
				tiles.color = 0xffffff;
				tiles.alpha = 1;
			}
			for (var xx:uint = sx; xx < ex; xx++)
			{
				for (var yy:uint = sy; yy < ey; yy++)
				{
					var tile:uint = get_at(xx, yy);
					if (!tile) continue;
					
					if (tile >= 200 && !(anim%10) && !shadow)
					{
						tile = tile ^ 0x10;
						set_at(xx, yy, tile);
					}
					var point:Point = new Point(xx * tw + x, yy * th + y);
					
					if ((tile >= 176 && tile < 224) && false)
					{
						tiles.frame = 112;
						tiles.render(FP.buffer, point, FP.camera);
						tiles.frame = tile;
						
					}
					if (shadow)
					{
						tiles.frame = tile;
						tiles.render(FP.buffer, new Point(point.x+4,point.y+4), FP.camera);

						continue;
					}
					tiles.frame = tile;
					tiles.render(FP.buffer, point, FP.camera);
				}
			}
		}
		
		override public function render():void
		{
			render2(1);
			render2(0);
		}
	}
}
