package
{
	import flash.display.MorphShape;
	import flash.geom.Point;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	public class Levelworld extends World
	{
		[Embed(source='gfx/tile.png')]
		protected var TILES:Class;
		
		[Embed(source = 'gfx/home.bin', mimeType = "application/octet-stream")]
		protected var MAP1:Class;
		
		[Embed(source = 'gfx/work.bin', mimeType = "application/octet-stream")]
		protected var MAP2:Class;
		
		[Embed(source = 'gfx/market.bin', mimeType = "application/octet-stream")]
		protected var MAP3:Class;
		
		[Embed(source = 'gfx/house.bin', mimeType = "application/octet-stream")]
		protected var MAP4:Class;
		
		[Embed(source = 'gfx/dream.bin', mimeType = "application/octet-stream")]
		protected var MAP5:Class;
		
		[Embed(source = 'gfx/wake.bin', mimeType = "application/octet-stream")]
		protected var MAP6:Class;
		
		public var delay:uint = 0;
		
		public var delay3:uint = 500;
		
		public var fade:Image = Image.createRect(FP.width, FP.height);
		
		public function Levelworld(w:uint, h:uint,stage:uint,phase:uint )
		{
			// oh lookie, nothing here :P
			Q.level = this;
			Q.stage = stage;
			Q.phase = phase;
			FP.screen.color = Q.phasecol[Q.phase];
			fade.alpha = 0;
			
			for (var c:uint = 0; c < 40; c ++ ) add(new Motivate(Q.phasecol[phase], phase));
		}
		
		override public function begin():void
		{
			// creating the world: 
			// a 64x64 tiles map
			var map:DynamicTilemap;
			
			// loading gfx and map, each tile is 32x32 pixels
			if (Q.phase == Q.EAT)
			{
				map = new DynamicTilemap(20, 15);
				map.load(TILES, MAP1, 16, 16);
			} else if (Q.phase ==Q.WORK)
			{
				map = new DynamicTilemap(128, 15);
				map.load(TILES, MAP2, 16, 16);
			} else if (Q.phase ==Q.SHOP) {
				map = new DynamicTilemap(128, 15);
				map.load(TILES, MAP3, 16, 16);
			} else if (Q.phase ==Q.SLEEP) {
				map = new DynamicTilemap(20, 15);
				map.load(TILES, MAP4, 16, 16);
				delay =Q.people.length+50;
			}else if (Q.phase ==Q.BOOT) {
				map = new DynamicTilemap(128, 15);
				map.load(TILES, MAP5, 16, 16);
				//delay =150;
			}else if (Q.phase ==Q.WAKE) {
				map = new DynamicTilemap(20, 15);
				map.load(TILES, MAP6, 16, 16);
				delay =150;
			}
			Q.map = map;
			// adding the map to the world
			add(map);
			
		}
		
		override public function update():void
		{
			// nothing here aswell :)
			if (delay)
			{
				delay--;
				if (Q.phase == Q.SLEEP && delay>=50)
				{
					var m:Man = Q.people[delay-50];
					if (!m.dead)
					{
						while (m.food.length) { m.eat(); }
						if (m.stamina <= 0)
						{
							Q.map.set_at(m.tx, m.ty, 98);
							add(new Shout(m.tx * Q.map.tw + 8, m.ty * Q.map.th + 8, "DEAD", 0xff0000));
							m.dead = 1;
							Q.play(Q.die);
							trace("died!");
						}
					}
				} else if (Q.phase == Q.SLEEP && delay==49)
				{
					var m:Man = Q.player;
						if (m.stamina <= 0)
						{
							Q.map.set_at(m.tx, m.ty, 98);
							add(new Shout(m.tx * Q.map.tw + 8, m.ty * Q.map.th + 8, "DEAD", 0xff0000));
							m.dead = 1;
							Q.play(Q.die);
							trace(" you died!");
						}
				}
				if (!delay)
				{
					if (Q.player.dead)
					{
						Q.people = new Vector.<Man>;
						for (var c:uint = 0; c < Q.mans; c++)
			{
				Q.people.push(new Man(0, 0));
			}
						Q.player = new Player(0,0);
						Q.stage = 0;
						Q.phase = -1;
						Q.gameover = 1;
					} else {
						var win:uint = 1;
						for (var c:uint = 0; c < Q.people.length; c ++ )
						{
							if (!Q.people[c].dead) win = 0;
						}
						if (win)
						{
							Q.win = win;
							Q.real_bootman = 1;
						}
						
					}
					
					Q.phase_shift();
				}
				if (Q.phase == Q.WAKE && delay == 100)
				{
					Q.map.set_at(16, 9, 206);
					Q.map.set_at(16, 8, 205);
					Q.map.set_at(16, 7, 207);
					Q.play(Q.wake);
				}
			}
			
			if (Q.phase == Q.BOOT)
			{
				if (delay3) delay3--;
				if (Q.player.x > Q.map.sx - Q.map.tw * 5 || !delay3)
				{
					fade.alpha += .05;
					if (fade.alpha >= 1)
					{
						fade.alpha = 1;
						Q.phase_shift();
					}
				}
			}
			
			super.update();
		}
		
		override public function render():void
		{
			super.render();
			fade.render(FP.buffer, new Point, new Point);
		}
	}
}