package
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Planet extends Entity
	{
		[Embed(source = "gfx/planet.png")]
		public var PLANET:Class;
		
		[Embed(source = "gfx/logo.png")]
		public var LOGO:Class;
		
		public var activated:uint = 0;
		public var radius:Number = 65;
		public var sintime:Number = 0;
		public var sprite:Spritemap = new Spritemap(PLANET, 200, 200);
		public var logo:Image = new Image(LOGO);
		public var box:Image = Image.createRect(2, 6 );
		public var shadow:Image = Image.createCircle(3,0,.3);
		public const num:uint = 3;
		public var phase:uint = 0;
		public var done:uint = 0;
		
		public var begin:uint = 0;
		public var manqueue:uint = 0;
		public var angle:Number = 0;
		public var scale:Number = 1;
		public function Planet(phase:uint)
		{
			
			trace("planet got: " + phase);
			// create yourt entity here (look at player class)
			// make sure to alter the properties too (speed, etc)
			this.phase = phase;
			this.x = FP.halfWidth;
			this.y = FP.halfHeight;
			sprite.centerOrigin();
			logo.centerOrigin();
			box.centerOrigin();
			shadow.centerOrigin();
			logo.scale=.8
			
			//graphic = sprite;
		}

		
		
		override public function update():void
		{
			if (!begin)
			{
				if (phase)
			{
				for (var c:uint = 0; c < Q.people.length;c++ )
				{
					var m:Man = Q.people[c];
					m.x = Math.PI * 2 * (phase-1) / 3;
					m.y = 0;
					m.vx = 3 + Math.random() * 3;
					m.vy = 0;// 4 + Math.random() * 2;
				}
			}
			begin = 1;
			trace("begin!");
			}
			
			sintime += .01;
			angle = sintime;
			scale = .8 + Math.sin(sintime * 1.68) * .1;
			if (phase && done)
			{
				logo.alpha = FP.lerp(logo.alpha, 0, .1);
				logo.scale = FP.lerp(logo.scale, 1.2, .1);
			} else {
				logo.alpha = FP.lerp(logo.alpha, 1, .1);
				logo.scale = FP.lerp(logo.scale, .8, .1);
			}
			
			if (phase && !done)
			{
				done = 0;
				manqueue++;
				if (manqueue > Q.people.length) 
				{
					manqueue = Q.people.length;
					done = 1;
				}
				for (var c:uint = 0; c < manqueue;c++ )
				{
					
					var m:Man = Q.people[c];
					if (m.dead) continue;
					
					m.x += m.vx * .01;
					if (m.x > Math.PI * 2 * (phase) / 3)
					{
						m.x = Math.PI * 2 * (phase) / 3;
						m.y = 0;
					} else {
						done = 0;
					}
					m.y += m.vy;
					if (m.y < 0) 
					{
						m.y = 0
						m.vy = 0;
					}
					//m.vx = 2 + Math.random() * 2;
					if (!FP.rand(32) && Math.abs(m.y) < 1) 
					{
						m.vy = 2 + Math.random() * 3;
					}
					m.vy -= .3;
				}
			}
		}
		
		override public function render():void
		{
			sprite.frame = 0;
			sprite.angle = angle * FP.DEG;
			sprite.scale = scale;
			sprite.render(FP.buffer, new Point(x, y), FP.camera);
			
			if (phase)
			{
				for (var c:uint = 0; c < Q.people.length;c++ )
				{
					var m:Man = Q.people[c];
					if (m.dead) continue;
					var a:Number = m.x+angle;
					var xx:Number = Math.cos(a)*(radius+5)*scale+x;
					var yy:Number = Math.sin(a) * (radius+ 5) * scale+y;
					shadow.angle = a * FP.DEG - 90;
					shadow.scaleY = .5;
					shadow.render(FP.buffer, new Point(xx, yy), FP.camera);
					 xx = Math.cos(a)*(radius+m.y+10)*scale+x;
					 yy = Math.sin(a) * (radius + m.y + 10) * scale + y;
					box.angle = a * FP.DEG - 90;
					box.color = FP.colorLerp(m.color,0xffffff,.5);
					box.render(FP.buffer, new Point(xx, yy), FP.camera);
				}
			}
			
			for (var c:uint = 0; c < num; c++)
			{
				var a:Number = Math.PI * 2 * c / num + angle;
				var xx:Number;
				var yy:Number;
				sprite.frame = c + 1;
				sprite.angle = a * FP.DEG-90;
				sprite.scale = 1 + Math.sin(sintime * 5 + (c + 1) * 1.37) * .2;
				sprite.scale *= scale;
				xx = Math.cos(a) * radius*scale+x;
				yy = Math.sin(a) * radius*scale+y;
				sprite.render(FP.buffer, new Point(xx, yy), FP.camera);
			}
			if (!(FP.world is Info)) logo.render(FP.buffer, new Point(x, y), FP.camera);
			//super.render();
		}
		
	}
}
